Index: perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision 26cde205cd3bb7efbb854fcbb1984776650a4a7f)
+++ perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision 24398384d59218e8c0e50c2ee363d02423e18db9)
@@ -37,5 +37,5 @@
             BarnOwl::error("You are using IO::Socket:SSL 0.97, which \n" .
                            "contains bugs causing it not to work with barnowl's\n" .
-                           "jabber support. We recommend updating to the latest\n" .
+                           "Jabber support. We recommend updating to the latest\n" .
                            "IO::Socket::SSL from CPAN. \n");
             die("Not loading Jabber.par\n");
@@ -206,5 +206,5 @@
     my $roster = $conn->getRosterFromJID($jid);
     if ($roster) {
-        $blist .= "\n" . BarnOwl::Style::boldify("Jabber Roster for $jid\n");
+        $blist .= "\n" . BarnOwl::Style::boldify("Jabber roster for $jid\n");
 
         my @gTexts = ();
@@ -258,11 +258,14 @@
         jabberlogin => \&cmd_login,
         {
-            summary => "Log into jabber",
-            usage   => "jabberlogin JID [PASSWORD]"
+            summary => "Log in to Jabber",
+            usage   => "jabberlogin <jid> [<password>]"
         }
     );
     BarnOwl::new_command(
         jabberlogout => \&cmd_logout,
-        { summary => "Log out of jabber" }
+        { 
+            summary => "Log out of Jabber",
+            usage   => "jabberlogout [<jid>]" 
+        }
     );
     BarnOwl::new_command(
@@ -270,5 +273,5 @@
         {
             summary => "Send a Jabber Message",
-            usage   => "jwrite JID [-t thread] [-s subject]"
+            usage   => "jwrite <jid> [-t <thread>] [-s <subject>]"
         }
     );
@@ -291,23 +294,23 @@
         {
             summary     => "Jabber MUC related commands.",
-            description => "jmuc sends jabber commands related to muc.\n\n"
+            description => "jmuc sends Jabber commands related to MUC.\n\n"
               . "The following commands are available\n\n"
-              . "join <muc>  Join a muc.\n\n"
-              . "part <muc>  Part a muc.\n"
-              . "            The muc is taken from the current message if not supplied.\n\n"
-              . "invite <jid> <muc>\n"
+              . "join <muc>  Join a MUC.\n\n"
+              . "part <muc>  Part a MUC.\n"
+              . "            The MUC is taken from the current message if not supplied.\n\n"
+              . "invite <jid> [<muc>]\n"
               . "            Invite <jid> to <muc>.\n"
-              . "            The muc is taken from the current message if not supplied.\n\n"
-              . "configure <muc>\n"
+              . "            The MUC is taken from the current message if not supplied.\n\n"
+              . "configure [<muc>]\n"
               . "            Configures a MUC.\n"
               . "            Necessary to initalize a new MUC.\n"
               . "            At present, only the default configuration is supported.\n"
-              . "            The muc is taken from the current message if not supplied.\n\n"
-              . "presence <muc>\n"
+              . "            The MUC is taken from the current message if not supplied.\n\n"
+              . "presence [<muc>]\n"
               . "            Shows the roster for <muc>.\n"
-              . "            The muc is taken from the current message if not supplied.\n\n"
+              . "            The MUC is taken from the current message if not supplied.\n\n"
               . "presence -a\n"
               . "            Shows rosters for all MUCs you're participating in.\n\n",
-            usage => "jmuc COMMAND ARGS"
+            usage => "jmuc <command> [<args>]"
         }
     );
@@ -315,6 +318,6 @@
         jroster => \&cmd_jroster,
         {
-            summary     => "Jabber Roster related commands.",
-            description => "jroster sends jabber commands related to rosters.\n\n"
+            summary     => "Jabber roster related commands.",
+            description => "jroster sends Jabber commands related to rosters.\n\n"
               . "The following commands are available\n\n"
               . "sub <jid>     Subscribe to <jid>'s presence. (implicit add)\n\n"
@@ -331,8 +334,8 @@
               . "              May be specified more than once, will not remove <jid> from any groups.\n\n"
               . "-p            Purge. Removes <jid> from all groups.\n"
-              . "              May be combined with -g completely alter <jid>'s groups.\n\n"
+              . "              May be combined with -g.\n\n"
               . "-n <name>     Sets <name> as <jid>'s short name.\n\n"
               . "Note: Unless -n is used, you can specify multiple <jid> arguments.\n",
-            usage       => "jroster COMMAND ARGS"
+            usage       => "jroster <command> <args>"
         }
     );
@@ -392,5 +395,5 @@
     my $jidStr = $vars{jlogin_jid};
     if ( !$jidStr && $vars{jlogin_havepass}) {
-        BarnOwl::error("Got password but have no jid!");
+        BarnOwl::error("Got password but have no JID!");
     }
     else
@@ -421,5 +424,5 @@
         if ( !$status ) {
             $conn->removeConnection($jidStr);
-            BarnOwl::error("We failed to connect");
+            BarnOwl::error("We failed to connect.");
         } else {
             my @result = $client->AuthSend( %{ $vars{jlogin_authhash} } );
@@ -482,5 +485,5 @@
 
 sub cmd_logout {
-    return "You are not logged into jabber." unless ($conn->connected() > 0);
+    return "You are not logged into Jabber." unless ($conn->connected() > 0);
     # Logged into multiple accounts
     if ( $conn->connected() > 1 ) {
@@ -547,10 +550,10 @@
         'account=s' => \$from,
         'id=s'     =>  \$jwrite_sid,
-    ) or die("Usage: jwrite JID [-t thread] [-s 'subject'] [-a account]\n");
+    ) or die("Usage: jwrite <jid> [-t <thread>] [-s <subject>] [-a <account>]\n");
     $jwrite_type = 'groupchat' if $gc;
 
     if ( scalar @ARGV != 1 ) {
         BarnOwl::error(
-            "Usage: jwrite JID [-t thread] [-s 'subject'] [-a account]");
+            "Usage: jwrite <jid> [-t <thread>] [-s <subject>] [-a <account>]");
         return;
     }
@@ -646,5 +649,5 @@
         }
         else {
-            BarnOwl::error('You must specify an account with -a {jid}');
+            BarnOwl::error('You must specify an account with -a <jid>');
         }
         return $func->( $jid, $muc, @ARGV );
@@ -659,5 +662,5 @@
 
     $muc = shift @ARGV
-      or die("Usage: jmuc join MUC [-p password] [-a account]");
+      or die("Usage: jmuc join <muc> [-p <password>] [-a <account>]");
 
     die("Error: Must specify a fully-qualified MUC name (e.g. barnowl\@conference.mit.edu)\n")
@@ -680,5 +683,5 @@
 
     $muc = shift @args if scalar @args;
-    die("Usage: jmuc part MUC [-a account]") unless $muc;
+    die("Usage: jmuc part [<muc>] [-a <account>]") unless $muc;
 
     if($conn->getConnectionFromJID($jid)->MUCLeave(JID => $muc)) {
@@ -695,5 +698,5 @@
     $muc = shift @args if scalar @args;
 
-    die('Usage: jmuc invite JID [muc] [-a account]')
+    die('Usage: jmuc invite <jid> [<muc>] [-a <account>]')
       unless $muc && $invite_jid;
 
@@ -710,5 +713,5 @@
     my ( $jid, $muc, @args ) = @_;
     $muc = shift @args if scalar @args;
-    die("Usage: jmuc configure [muc]") unless $muc;
+    die("Usage: jmuc configure [<muc>]") unless $muc;
     my $iq = Net::Jabber::IQ->new();
     $iq->SetTo($muc);
@@ -751,5 +754,5 @@
 
     $muc = shift @args if scalar @args;
-    die("Usage: jmuc presence MUC") unless $muc;
+    die("Usage: jmuc presence [<muc>]") unless $muc;
 
     if ($muc eq '-a') {
@@ -817,5 +820,5 @@
         }
         else {
-            BarnOwl::error('You must specify an account with -a {jid}');
+            BarnOwl::error('You must specify an account with -a <jid>');
         }
         return $func->( $jid, $name, \@groups, $purgeGroups,  @ARGV );
@@ -841,5 +844,5 @@
     }
     else {
-        BarnOwl::error('You must specify an account with -a {jid}');
+        BarnOwl::error('You must specify an account with -a <jid>');
     }
 