Index: WS
===================================================================
--- NEWS	(revision 1aee7d914de75510e7cf09c452bad63b2dad2166)
+++ 	(revision )
@@ -1,281 +1,0 @@
-
-$Id$
-
-What's new in owl version 1.1
------------------------------
-* Generic filtering now exists
-
-* The filter command creates a filter
-
-* The view command narrows the view to a filter
-
-* The viewclass / vc command automatically narrows the view
-  to a particular class
-
-* The viewuser / vu command automatically narrows the view
-  to a particular user
-
-* M-n automatically narrows the view to whatever is appropriate for
-  the current message
-
-* v will start a view command
-
-* X will expunge and change the view to the view_home variable value
-
-* R will reply to sender
-
-* C-r and C-R will let the user edit the reply line
-
-* T now uses the 'trash' filter
-
-* T tells you how many messages were marked for deletion
-
-* The local realm has been removed from login/logout messages
-
-* Command history works
-
-* Prettier status command
-
-* Leave the pointer near the current message after an expunge
-
-* C-l recenters the typing window
-
-* zlocate is implemented
-
-* @italic works like @i
-
-* Unecessary quoting and options in reply lines have been removed
-
-* Errors in the 'info' command don't show up in a popup now
-
-* Implemented the aexec, pexec commands
-
-* The zsig now gets zephyr formatting
-
-* Messages now have message id's. They are displayed in 'info' and are
-  passed to the config as $owl::id.
-
-* The 'show' command is implemented to display info about filters.
-
-* M-D marks for deletion all messages in the current view
-
-* added the delete command
-
-* load-subs with no argument loads the default subscription file
-
-* "Truncated" is now displayed when the *current* message is truncated
-  not when the last displayed message is truncated.
-
-* The reply-lockout filter locks out replies to some classes
-
-* In the configfile owl::receive_msg is run when a message is
-  received.
-
-* Added the beep command
-
-* Added the contributors file
-
-* zaway, zaway_msg and zaway_msg_default are all user variables now
-
-* There is a zsig variable that overrides other zsig mechanisims
-
-* The appendtosepbar variable exists to allow the config to display
-  things in the sepbar
-
-* login messages are included as 'trash' messages by default now
-
-* Fixed a memory corruption bug in readconfig.c
-
-* There are example configs in the distribution now
-
-* Implemented the perl, aperl and pperl commands
-
-* FIxed bug with zsigproc zombies
-
-* Can disable zsigproc after setting it now
-
-* There is support for multiple browsers with the 'webbrowser'
-  variable.
-
-* Set now takes a -q option to not echo
-
-* debug is now a variable that can be turned on and off
-
-* Don't allow " and \ characters in URLs passed to a webbrowser
-
-* Build system cleaned up some
-
-* Pop up windows are wider by default
-
-* Fix to work with older versions of libzephyr
-
-* PageUp and PageDown work in the main window and in popups
-
-* Added doc/code.txt describing the code layout
-
-
-What's new in owl version 1.0
------------------------------
-* 'print' and 'set' with no arguments prints all variables
-
-* The 'unsub' command renamed to 'unsuball'
-
-* 'unsubscribe' (and 'unsub') command
-
-* 'getsubs' command to print subscriptions
-
-* Bug fixed in logging messages to more than one recipient
-
-* Support for zwrite options -C, -O and -n
-
-* Fixed owl_editwin_delete_char bug when there are no chars after the
-  cursor
-
-* Display 'more' and 'truncated' in the status bar
-
-* Enable printing of the 'zsigproc' and 'loginsubs' variables
-
-* Only allow message scrolling if the message is longer than the
-  screen
-
-* 'P' (capitolized) will advance the pointer to the next personal
-  message.  'M-P' will move the pointer to the previous personal
-  message.
-
-* 'T' will mark certain "trash" messages for deletion.  This includes:
-  mail notifications, pings and admin messages.
-
-* Replying to a login/logout message sends as a personal message to
-  the user
-
-* Replying to an admin message that's an outgoing message copy sends
-  as a personal message to the user
-
-* 'status' command
-
-* intro document added to the release
-
-* The local realm is trimmed everywhere, including in logging
-
-* Fixed off by one bug in scrolling popups
-
-* Complete on line help added
-
-* Pass the realm to the config file in $owl::realm
-
-* Word wrap and scroll at the bottom right corner of the editing
-  window
-
-* Fixed a bug in editwing window key_right past the last character
-
-* Print an error and don't start owl if the configfile can't be
-  parsed
-
-* Fix bug where the only message displayed might not be the current
-  message
-
-* Don't display the M-^Z key error on resize
-
-What's new in owl version 0.11
-------------------------------
-* Bug fixed in viewing messages longer than a screen
-
-* Indicate in the sepbar if there is a vertical offset present
-
-* '.' on a line by itself will send a zephyr
-
-* disable-ctrl-d variable will disable sending on C-d
-
-* bug fixed that kept C-k from deleting a final newline
-
-* make non-character meta keys work
-
-* fixed phatom zephyr problem
-
-* <, >, M-< and M-> work in popups now
-
-* removed extra spaces at bottom of a popup
-
-* Added "about" command
-
-* Fixed bug using 'M' with no current message
-
-* Log personal messages to 'all' as well as the personal file
-
-* Messages take up less memory
-
-What's new in owl version 0.10
-------------------------------
-* Scrollable / pageable popup windows.  They act like the 'less' or
-  'more' programs.
-
-* Scrolling within a message, to facilitate reading messages longer
-  than the screen size.
-
-* The command parser deals with quoting.  i.e. zwrite -c "foo class"
-  now works.
-
-* The slow cut and paste bug is fixed.
-
-* C-v and M-v will page down and up in the main window, respectively.
-
-* A bug in redrawing the popup windows is fixed.
-
-* An error is displayed when non-functional keys are pressed.
-
-* @i() formatting is displayed as underlined in curses.
-
-* Curly braces work for zephyr formatting.
-
-* The popup window size is relatively larger on small terminals
-
-* A bug in having meta keys work on eight bit input xterms is fixed.
-
-* The cursor location is more consistent.
-
-
-What's new in owl version 0.9
------------------------------
-* Many emacs meta keys work
-
-  M-q, M-f, M-b, M-d, M-< and M-> now work in the typing window
-  M-< and M-> also work in the main window
-  M-x in the main window now enters command mode, just like ':'
-
-* The typing window will automatically word-wrap when hitting the
-  end of the line
-
-* SmaatBolding (TM)
-
-  Users without a .zephyr.subs won't have personal messages
-  displayed in all bold
-
-* Realm displayed for interrealm zephyrs
-
-* 'personalbell' variable printing fixed
-
-* bug with ringing terminal bell on pings fixed
-
-
-What's new in owl version 0.8
------------------------------
-* personal logging
-  
-  "set logging on" will turn on personal logging.  By default messages
-  will go to ~/zlog/people.  This path can be changed by setting the
-  "logpath" variable.
-
-* class logging
-
-  "set classlogging on" will turn on class logging.  By default
-  messages will go to ~/zlog/class.  This path can be changed by
-  setting the "classlogpath" variable.
-
-* variable for resizeing the typing window
-
-  "set typewinsize <n>" will change the number of lines in the typing
-  window to n.
-
-* fixed bugs with backspace
-
-* -v command line option prints the version number